#include "GPS.h"

void wait(void);
void UART_Write(char data);

int array_count;
char output_char;
char data[];
char* read_values_GPS(void) {
    config_UART();
    
    ANSELB = 0; 
    ANSELC = 0; 
    ANSELD = 0; 

    output_char = getu2();
    if(output_char =='$'){
        output_char = getu2();
        if (output_char == 'G'){
            output_char = getu2();
            if(output_char == 'N'){
                output_char = getu2();
                if(output_char == 'G'){
                    output_char = getu2();
                    if(output_char == 'G'){
                        output_char = getu2();
                        if(output_char == 'A'){
                            output_char = getu2();
                            if(output_char ==','){
                                output_char = getu2();
                                for(array_count = 0; output_char != '\r'; array_count++){
                                    data[array_count] = output_char;
                                    output_char = getu2();
                                            
                                        }
                                return data;
                                    }    
                                                 
                                }
                                    
                            }
                        }
                    
                }
            }
        }
       
              
         
    }
        
void wait() {
    unsigned int i, j;
    for (i=0; i<20; i++){
        for (j=0; j<2500; j++) {}
    }
}

void config_UART(void){
    U1RXRbits.U1RXR = 0b0100;
    RPF0Rbits.RPF0R = 0b0011;
    
    U2RXRbits.U2RXR = 0b0101;
    RPE5Rbits.RPE5R = 0b0001;
    
    U1MODEbits.ON = 0;          //turns it on
    U1MODEbits.UEN = 0b00;      // enables rx and tx
    U1MODEbits.PDSEL = 0;       // no parity
    U1MODEbits.STSEL = 0;       // 1 stop bit 
    int Clock = 10000000;     // the original value
    //int Clock = 7812;
    unsigned long Rate = 9600;
    //unsigned long Rate = 75;
    int Baud = (Clock/Rate/4) - 1;                 // prescaler
    U1MODEbits.BRGH = 1;        // baud rate generator prescaler 
    U1BRG = Baud;
    U1MODEbits.ON = 1; 
    U1MODEbits.UARTEN = 1;      // enables rx and tx bits
    U1STAbits.UTXEN = 1;        //enables transmit 
    U1STAbits.URXEN = 1;        // enables receive  
    
    //UART 2 Configuration
    
    U2MODEbits.ON = 0;          //turns it on
    U2MODEbits.UEN = 0b00;  //U1TX, U1RX enable
    U2MODEbits.PDSEL = 0b00; //8 bit data, no parity
    U2MODEbits.STSEL = 0;   //1 stop bit
    
    U2MODEbits.BRGH = 1;        // baud rate generator prescaler 
    U2BRG = Baud;
    U2MODEbits.ON = 1;
    U2MODEbits.UARTEN = 1;  //Enable UART 
    U2STAbits.URXEN = 1;    //UART 2 receiver and transmitter enable
    U2STAbits.UTXEN = 1; 
}

void putch(char *c) {
    int i;
    for(i=0;i<strlen(c);i++){
        UART_Write(c[i]);
    }
}

char getu2(){
    //loop to wait for data
    while(!U2STAbits.URXDA){
    }
    return(U2RXREG);    //return data to the transmit register
}

void UART_Write(char data)
{
  while(U1STAbits.UTXBF);
  U1TXREG = data;
}

void putu1(char data){
    U1STAbits.UTXEN = 1;
    while(U1STAbits.UTXBF){
        //wait for the transmit buffer to be empty
    }
    U1TXREG = data; //write the data to the transmit reg
}
