/* 
 * File:   config.h
 * Author: Matt
 *
 * Created on March 28, 2016, 10:51 PM
 */

#ifndef CONFIG_H
#define	CONFIG_H

// FICD
#pragma config FNOSC = FRCPLL //0b011        //pg 268 8MHZ X
#pragma config POSCMOD = OFF //0b10       //HS select, high speed crystal X
#pragma config FPLLIDIV = DIV_2//0b001     // 2 divider, 8--->4 
#pragma config FPLLMUL = MUL_20 //0b101      // x20 multiplier, 4* 20 = 80Mhz
#pragma config FPLLODIV = DIV_1 //0b000     // divide by 1, 80MHz

#pragma config FPBDIV = DIV_8//0b11        //Divides by 8, 80/8 = 10MHz
#pragma config FSOSCEN = OFF//0b0        //Secondary off

#pragma config FWDTEN = OFF//0b0         //Watchdog timer off
#pragma config IESO = ON//1             //Enable clock switch over
#pragma config FCKSM = CSECME            //Clock switching enabled, fail safe monitor enabled

#pragma config DEBUG = OFF
#pragma config ICESEL = ICS_PGx1

#endif