#include "config.h"
#include "SPI.h"
#include "SX1276.h"
#include "UART.h"
#include "MPL3115A2alt.h"
#include <xc.h>

void main(void) {        
    struct Temperature altitude = {0,0};
    
    config_SPI();
    config_UART();
    config_MPL3115A2();

    while(!begin(915000000)){
        wait_ms(1000);
    }
      
    /* Receiving Code */
    while(1){
        altitude = read_values_MPL3115A2();
        
        int packetSize = parse_packet(0);
        if (packetSize) {       
            while (available()){
                putch(read()); 
                
            }
        }
    }
}