#include "uart.h"

void wait() {
    unsigned int i, j;
    for (i=0; i<20; i++){
        for (j=0; j<2500; j++) {}
    }
}

void config_UART(void){
    U1RXRbits.U1RXR = 0b0100;
    RPF0Rbits.RPF0R = 0b0011;
    
    U1MODEbits.ON = 0;          //turns it on
    U1MODEbits.UEN = 0b00;      // enables rx and tx
    U1MODEbits.PDSEL = 0;       // no parity
    U1MODEbits.STSEL = 0;       // 1 stop bit 
    int Clock = 10000000;     // the original value
    unsigned long Rate = 57600;
    int Baud = (Clock/Rate/4) - 1;                 // prescaler
    U1MODEbits.BRGH = 1;        // baud rate generator prescaler 
    U1BRG = Baud;
    U1MODEbits.ON = 1; 
    U1MODEbits.UARTEN = 1;      // enables rx and tx bits
    U1STAbits.UTXEN = 1;        //enables transmit 
    U1STAbits.URXEN = 1;        // enables receive  
}

void putch(char f) {
    while(U1STAbits.UTXBF);
    U1TXREG = f; 
}

void send_string(char *c){
    int i;
    for(i=0; i<strlen(c); i++){
        putch(c[i]);
    }
}

