/* 
 * File:   main.c
 * Author: Matth
 *
 * Created on February 23, 2022, 7:50 PM
 */

#include <stdio.h>
#include <stdlib.h>
//#include <proc/p32mx470f512h.h>
#include "config.h"
#include "uart.h"
#include <xc.h>

int main(int argc, char** argv) {
    config_UART();
    while(1){
        putch('k');
        putch('o');
        putch('n');
        putch('r');
        putch('a');
        putch('d');
        putch('\n');
    }
    while(1);
}
    
void config_UART(void){
    U1RXRbits.U1RXR = 0b0100;
    RPF0Rbits.RPF0R = 0b0011;
    
    U1MODEbits.ON = 0;                  // turns it on
    U1MODEbits.UEN = 0b00;              // enables RX and TX
    U1MODEbits.PDSEL = 0;               // no parity
    U1MODEbits.STSEL = 0;               // 1 stop bit 
    int Clock = 10000000;
    unsigned long Rate = 57600;
    int Baud = (Clock/Rate/4) - 1;      // pre-scaler
    U1MODEbits.BRGH = 1;                // baud rate generator pre-scaler 
    U1BRG = Baud;
    U1MODEbits.ON = 1; 
    U1MODEbits.UARTEN = 1;              // enables RX and TX bits
    U1STAbits.UTXEN = 1;                //enables TX 
    U1STAbits.URXEN = 1;                // enables RX  
}

void putch(char c) {
    while(U1STAbits.UTXBF);
    U1TXREG = c;
}

