/* 
 * File:   config.h
 * Author: rls
 *
 * Created on March 28, 2016, 10:51 PM
 */

#ifndef CONFIG_H
#define	CONFIG_H

// FICD
#pragma config FNOSC = 0b011        //pg 268
#pragma config POSCMOD = 0b10
#pragma config FPLLIDIV = 0b01
#pragma config FPLLODIV = 0b00
#pragma config FPLLMUL = 0b101
#pragma config UPLLIDIV = 0b001

#pragma config FPBDIV = 0b11
#pragma config FSOSCEN = 0b0
#pragma config FWDTEN = 0b0


//#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
//#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
//
//// FPOR
//#pragma config WDTWIN = WIN25           // Watchdog Window Select bits (WDT Window is 25% of WDT period)
//
//// FWDT
//#pragma config WDTPOST = PS32768        // Watchdog Timer Postscaler bits (1:32,768)
//#pragma config WDTPRE = PR128           // Watchdog Timer Prescaler bit (1:128)
//#pragma config PLLKEN = ON              // PLL Lock Enable bit (Clock switch to PLL source will wait until the PLL lock signal is valid.)
//#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
//#pragma config FWDTEN = OFF             // Watchdog Timer Enable bit (Watchdog timer always enabled)
//
//// FOSC
//#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
//#pragma config OSCIOFNC = ON            // OSC2 Pin is digital output pin
//#pragma config IOL1WAY = OFF            // Peripheral pin select configuration (Allow multiple reconfigurations)
//#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
//
//// FOSCSEL
//#pragma config FNOSC = FRC              // Oscillator Source Selection (Internal Fast RC (FRC))
//#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up device with FRC, then switch to user-selected oscillator source)
//
//// FGS
//#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
//#pragma config GCP = OFF                // General Segment Code-Protect bit (General Segment Code protect is Disabled)

#endif

