/* 
 * File:   main.c
 * Author: Matth
 *
 * Created on February 23, 2022, 7:50 PM
 */

#include <stdio.h>
#include <stdlib.h>
#include <proc/p32mx470f512h.h>
#include "config.h"
#include "uart.h"

/*
 * 
 */

int main(int argc, char** argv) {
    config_UART();
    float i = 0;
    while(i<=100){
        printf("\r%.2f\n", i);
        i = i +0.25;
    }
    while(1);
}
    

void config_UART(void){
    U1MODEbits.ON = 1;          //turns it on
    U1MODEbits.BRGH = 1;        // baud rate generator presclaer 
    U1BRG = ((FCY/BAUDRATE)/4) -1;                 // prescaler 
    U1MODEbits.PDSEL = 0;       // no parity
    U1MODEbits.STSEL = 0;       // 1 stop bit 
    U1MODEbits.UEN = 0b00;      // enables rx and tx
    U1MODEbits.UARTEN = 1;      // enables rx and tx bits
    U1STAbits.UTXEN = 1;        //enables transmit 
    U1STAbits.URXEN = 1;        // enables receive  
}

void putch(char c) {
    while(U1STAbits.UTXBF);
    U1TXREG = c; 

}

